
////////////////////////////////////////////////////////////////////////////
//  Name    : Zegar LED5x7.c                                          	  //
//  Author  : [Krzysztof Pawsiuk]                                        //
//  Notice  : Copyright (c) 2003                                          //
//  Compil. : CCS PCM C Compiler, Version 3.045, 12391                    //
//  Date    : 2003-03-11                                                  //
//  Version : 1.0                                                         //
//  Notes   :  				                                              //
//          :                                                             //
////////////////////////////////////////////////////////////////////////////
#include <16f628.h>
#include <f628.h>

#rom 0x2007={0b00000001010000}	//konfiguracja bezpiecznikow
#use delay(clock=4000000)
#id 0,3,0,3

#define led_port portb			//port sterowania katodami 0...5
#define led_tris trisb
#define R6 porta_6				//pin sterujacy katoda 6
#define C1 porta_0				//pin sterujacy anoda 1
#define C2 porta_1				//pin sterujacy anoda 2
#define C3 porta_2				//pin sterujacy anoda 3
#define C4 porta_3				//pin sterujacy anoda 4
#define C5 porta_7				//pin sterujacy anoda 5
#define KEY1 porta_5			//pin klawisza S1
#define KEY2 porta_4			//pin klawisza S2
#define timer1_set 0			//2s dla kwarcu 32,768
#bit tmr1if =0x0c.0
#bit tmr0if = 0x0b.2
int sek, min, godz;				//komorki do odliczania czasu
int buf[42];					//bufor zapisanych cyfr czasu
int nr;							//numer komorki w buforze do wyswietlaenia
int anoda;						//numer wspolnej anody diod aktualnie wyswietlanych
int16 rotate,speed;				//predkosc przesuwania napisu
boolean rot_on;					//jesli=1, to pozwala na przesuwanie napisu
//definicja cyfr
byte const cyfra[66]={0x3E,0x51,0x49,0x45,0x3E,0,  /* 0x30: 0  */
                      0x00,0x42,0x7F,0x40,0x00,0,  /* 0x31: 1  */
                      0x42,0x61,0x51,0x49,0x46,0,  /* 0x32: 2  */
                      0x21,0x41,0x45,0x4B,0x31,0,  /* 0x33: 3  */
                      0x18,0x14,0x12,0x7F,0x10,0,  /* 0x34: 4  */
                      0x27,0x45,0x45,0x45,0x39,0,  /* 0x35: 5  */
                      0x3C,0x4A,0x49,0x49,0x30,0,  /* 0x36: 6  */
                      0x01,0x01,0x79,0x05,0x03,0,  /* 0x37: 7  */
                      0x36,0x49,0x49,0x49,0x36,0,  /* 0x38: 8  */
                      0x06,0x49,0x49,0x29,0x1E,0,  /* 0x39: 9  */
					  0x00,0x36,0x36,0x00,0x00,0}; /* 0x3a: :  */


//////////////////////////////////////////////////////////////////////
program();
ramset(int mode);						//przepisuje godzine do bufora wyswietlania

main()
{int i;
cmcon=7;								//porta jako cyfrowy
pcon=0xff;
porta=0;
trisa=0x00110000;
led_port=0;
led_tris=0;
sek=0;min=0;godz=0;
rotate=0;
speed=200;								//poczatkowa predkosc przewijania

for(i=0;i<42;i++) buf[i]=0;     		//zeruj bufor wyswietlania
nr=0;
rot_on=1;								//wlacz przesuwanie napisu

t1con=0b00001011;						//timer1 z zewnetrznego kwarcu,preskaler/1
tmr1ie=1;								//wlacza przerwanie od t1
set_timer1(timer1_set);					//ustawienie wartosci poczatkowej timera t1

//*****************************************************
set_rtcc(0);
setup_counters( RTCC_INTERNAL, RTCC_DIV_4);
enable_interrupts(INT_RTCC);
enable_interrupts(GLOBAL);
trisa_4=1;
while(1)
	{
	if(!key1&&!key2)					//jesli nacisnieto dwa klawisze, to
		{delay_ms(1000);				//idz do programowania czasu
		if(!key1&&!key2) program();
		}
	if(!key2)							//jesli key2, to zwieksz predkosc
		{if(--speed<50) speed=50;		//przewijania
		delay_ms(30);}
	if(!key1)							//jesli key1, to zmniejsz predkosc
		{if(++speed>1000) speed=1000;
		delay_ms(30);
		}

	}

}


//************************************************************************//
//  przepisuje godzine i minuty do ramu w formacie cyfr		              //
// jesli mode=0, to wygasza zero w dziesiatkach minut
//************************************************************************//
ramset(int mode)
{int i,j,temp1,temp2,temp3,temp4;
	temp1=godz/10;
	temp2=godz%10;
	temp3=min/10;
	temp4=min%10;
	for(j=0;j<6;j++) buf[j]=0;
if(mode==0)
	{
	if(temp1>0)
		{
		i=temp1*6;
		for(j=6;j<12;j++)					//zapisuje do bufora znak dzisiatek godzin
			buf[j]=cyfra[i++];
		}
	else 	{for(j=6;j<12;j++)				//zapisuje do bufora znak dzisiatek godzin
			buf[j]=0;}
	}
else {i=temp1*6;
		for(j=6;j<12;j++)					//zapisuje do bufora znak dzisiatek godzin
			buf[j]=cyfra[i++];
	 }


	i=temp2*6;
	for(j=12;j<18;j++)						//zapisuje do bufora znak jednosci godzin
			buf[j]=cyfra[i++];
	i=60;
	for(j=18;j<23;j++)						//zapisuje do bufora znak :
			buf[j]=cyfra[i++];
	i=temp3*6;
	for(j=23;j<29;j++)						//zapisuje do bufora znak dzisiatek minut
			buf[j]=cyfra[i++];
	i=temp4*6;
	for(j=29;j<35;j++)						//zapisuje do bufora znak jednostek minut
			buf[j]=cyfra[i++];
	for(j=35;j<41;j++) buf[j]=0;
}
//************************************************************************//


//*********************************************************************************//
//Obsluga przerwania od tmr0 co ok. 1ms									 		   //
//*********************************************************************************//
#int_rtcc
void timer0()
{	tmr0if=0;								//przyjmij przerwanie
	porta&=0b01110000;						//wycz wszystkie kolumny
	R6=1;									//wylacz wiersz R7
	switch(anoda)							//w zaleznosci od wartosci anoda
	{										//wyswietl dane dla odpowieniej kolumny
	case 0:									//dla 0 wyswietl dane dla kolumny C1
			R6=~bit_test(buf[nr],6);		//do wiersza R6, zanegowany bit6 buf[nr]
			led_port=~buf[nr];				//do porta zanegowany bajt buf[nr]
			c1=1;break;
	case 1:
			R6=~bit_test(buf[nr+1],6);		//dla 0 wyswietl dane dla kolumny C2
			led_port=~buf[nr+1];			//do wiersza R6, zanegowany bit6 buf[nr+1]
			c2=1;break;						//do porta zanegowany bajt buf[nr+1]
	case 2:
			R6=~bit_test(buf[nr+2],6);		//dla 0 wyswietl dane dla kolumny C3
			led_port=~buf[nr+2];			//do wiersza R6, zanegowany bit6 buf[nr+2]
			c3=1;break;						//do porta zanegowany bajt buf[nr+2]
	case 3:
			R6=~bit_test(buf[nr+3],6);		//dla 0 wyswietl dane dla kolumny C4
			led_port=~buf[nr+3];			//do wiersza R6, zanegowany bit6 buf[nr+3]
			c4=1;break;						//do porta zanegowany bajt buf[nr+3]
	case 4:
			R6=~bit_test(buf[nr+4],6);		//dla 0 wyswietl dane dla kolumny C5
			led_port=~buf[nr+4];			//do wiersza R6, zanegowany bit6 buf[nr+4]
			 c5=1;break;					//do porta zanegowany bajt buf[nr+4]
	}

	if(++anoda>5) anoda=0;					//jesli anoda>5 to zeruj
//------------------------------------
	if(rot_on)							 	//czynnosci potrzebne do przewijania
		{if(++rotate>speed)					//cyfr
			{rotate=0;
		 	if(++nr>36) nr=0;
			}
		}
	else rotate=0;

}
//************************************************************************************//

//****************************************************************************//
//Przerwanie nastepuje co 2s dla kwarcu 32,768 i dlatego tmr1 pracuje z pelna //
//pojemnosci 65535(0xffff) i nie trzeba tmr1 ladowac nowa wartoscia           //
//****************************************************************************//
#int_timer1
void tmr1()
{tmr1if=0;								//przyjmij przerwanie od tmr1
if(++sek>29)							//jesli sekundy > od 29, minela minuta
	{sek=0;								//zeruj sekundy i zwieksz minuty
	 if(++min>59)						//jesli zwiekszone minuty sa >59
	 	{min=0;							//to zeruj minuty i zwieksz godziny
		if(++godz>23)					//jesli zwiekszone godziny sa >23
	 		godz=0;						//to zeruj godziny
	 	}
	}
ramset(0);								//wpisz nowy czas do pamieci
}
//**************************************************************************//


//************************************************************************//
// programowanie czasu                                                    //
//************************************************************************//
program()
{int gd=0,gj=0,md=0,mj=0;
while(nr<36);							//czekaj na przewinicie tekstu do konca
rot_on=0;								//wylacza przesuwanie napisu
nr=0;									//ustawianie dziesiatek godzin
disable_interrupts(int_timer1);			//zatrzymaj tmr1

delay_ms(500);
gd=godz/10;								//do gd wpisz dziesiatki godzin
gj=godz%10;								// do gj jednostki godzin
md=min/10;								//do md dziesiatki minut
mj=min%10;								//do mj jednostki minut
ramset(1);

while(++nr<6) delay_ms(200);
while(!key1&&!key2);
delay_ms(300);
while(key1)								//ustawianie dziesiatek godzin
	{if(!key2)
		{
		 if(++gd>2) gd=0;
		 godz=gj+gd*10;
		 ramset(1);
		 delay_ms(300);
		 }
	}

while(!key1);
delay_ms(200);
//nr=12;								//ustawianie jednostek godzin
while(++nr<12) delay_ms(200);
if(gd==2&&gj>3)
		{while(--gj>2)
			{delay_ms(400);
			 godz=gj+gd*10;				//jesli dziesiatki <2, to liczy do 9
		 	 ramset(1);
		 	 }
		 }
while(key1)
	{if(!key2)
		{
		 gj++;
		 if(gd==2) if(gj>3) gj=0;
		 else if(gj>9) gj=0;
		 godz=gj+gd*10;					//jesli dziesiatki <2, to liczy do 9
		 ramset(1);
		 delay_ms(300);
		 }
	}
while(!key1);
delay_ms(200);
//nr=24;								//ustawianie dziesiatek minut
while(++nr<23) delay_ms(200);
while(key1)
	{if(!key2)
		{
		 if(++md>5) md=0;
		 min=mj+md*10;
		 ramset(1);
		 delay_ms(300);
		 }
	}
while(!key1);
delay_ms(200);
//nr=30;								//ustawianie jednostek minut
while(++nr<29) delay_ms(200);
while(key1)
	{if(!key2)
		{
		 if(++mj>9) mj=0;
		 min=mj+md*10;
		 ramset(1);
		 delay_ms(300);
		 }
	}
nr=0;									//ustaw na poczatek napisu
rot_on=1;								//zezwol na przesuwanie napisu
sek=0;
set_timer1(timer1_set);					//ustaw nowa wartosc tmr1
enable_interrupts(int_timer1);			//wlacz przerwanie od tmr1
delay_ms(300);

}
//************************************************************************//