////////////////////////////////////////////////////////////////////////////
//  Name    :	zamek_DS1990.c                                            //
//  Author  : [Krzysztof Pawsiuk]                                        //
//  Notice  : Copyright (c) 2003 		                                  //
//  Compil. : CCS PCM C Compiler, Version 3.045, 12391                    //
//  Date    : 2003-03-06                                                  //
//  Version : 1.0                                                         //
//  Notes   :                                                             //
//          : 				                                              //
////////////////////////////////////////////////////////////////////////////
#include <12f675.h>
#include <f675.h>

// 	BG1	BG0	 NC   NC  NC  CPD  CP BODEN MCLR PWRTE WDTE FOSC2 FOSC1 FOSC0
//  13  12   11   10   9   8   7    6    5    4     3     2   1      0
//   1	 1    0	   0   0   1   1    1    0    0     0     1   0      0
//  BG-HVolt             OFF  OFF   ON  PIN  ON    OFF   INTER RC

#rom 0x2007={0b11000111000100}
#use delay(clock=4000000)

#id 0,3,0,3
#include <touch.c>							//obsluga 1wire
#include <crc8.h>							//obsluga crc8

int mode;									//w bajcie tym zapisany jest wynik pomiaru AC
byte buffer[8];								//bufor numeru seryjnego
#define prog_pin pin_a3						//wejscie programowania
#define green pin_a1						//dioda zielona
#define red	pin_a2							//dioda czerwona
#define out gpio_5							//port sterujacy tranzystorem

programowanie();							//obsluga zapisu kluczy
read_ds();									//czeka na dotkniecie ds i odczytuje numer, nastepnie zapisuje do bufora

main()
{
byte i,j, adr,prog,prmin,prmax; 			//zmienne pomocnicze
boolean ok;
osccal=0b10110100;							//ustalenie czestotliwosci oscylatora
pcon=0;
cmcon=7;									//porty jako cyfrowe
trisio_5=0;
out=0;										//tranzystor wylaczony

//odczytuje warto napicia na wejciu gpio4 i na tej podstawie okreslana, jest
//reakcja procesora na prawidlowy kod DS1990
ansel=0b01101000;							//konfiguracja GP4 jako wejscie
delay_us(500);								//przetwornika A/C
adcon0=0b00001101;							//A3, wlacza A/C, start konwersji
delay_us(500);
bit_set(adcon0,go);							//start pomiaru napicia
while(bit_test(adcon0,go));					//czekaj na koniec konwersji
mode=adresh;								//przepisuje wartosc napiecia do mode
//-----------------------------------------------------------------------
///mierzy napiecie na glowicy czytnika
ansel=0b01101001;							//gpio0 analog
delay_us(500);
adcon0=0b00000001;							//A0, wlacza A/C
delay_us(500);
bit_set(adcon0,go);							//start pomiaru napicia
while(bit_test(adcon0,go));					//czekaj na koniec konwersji

if(!input(prog_pin))
	{if(adresh<254&&adresh>5)
		{write_eeprom(121,adresh);			//jesli napiecie na glowicy jest mniejsze niz vcc
											//i zwarta jest zworka to oznacza, ze jest dodatkowy rezystor i wartosc napiecia
											//zostanie zapisana do eeprom
		while(1)
			{output_high(green);
			 delay_ms(200);
			 output_low(green);
			 delay_ms(200);
			 }
		}
	 else if(adresh>253)					//jesli zas napiecie jest bliskie VCC, to programowanie przez
	 		{write_eeprom(121,0xff); 		//zwarcie zworki, do EEPROM zapisuje 0Xff, aby
	 		programowanie();				//wylaczyc tryb progr. przez przylozenie rezystora do glowicy
	 		}
	}
/////////////////////////////////////////////////////////////////////////

prog=read_eeprom(121);						//odzytaj wartosc napiecia na glowicy,przy ktorej
											//mozliwe bedzie wlaczenie programowania przez rezystor
if(prog<0xff)								//jesli w eepromie jest zapisana wartsc napiecia<5V
	if(adresh>prog-3&&adresh<prog+3)programowanie(); //to sprawdz czy, zmierzone napiecie
											//miesci sie w zakresie napiecia zaprogramowanego +-60mv,ok.1%
bit_clear(ansel,0);							//gpio0 jako cyfrowy

while (TRUE)
	{
    if(read_ds()==0)						//jesli odczytano klucz z prawidlowa suma crc
    	{
    	j=0;								//ustawia numer klucza w pamieci eeprom
    	do									//przeszukaj pamiec, czy jest zgodny klucz
    	  {ok=0;							//zeruj flage dobrego klucza
       		adr=j*8;						//ustal adres dla klucza o numerze j
       		for(i=0;i<8;i++)				//porownaj 8bajtow odebranego klucza z zapisanym w pamieci
           		if(buffer[i]!=read_eeprom(adr++)) ok=1;//jesli klucz bledny to ustaw ok
	  	  }while(++j<15&&ok);				//przeszukuje do 15 kluczy 8bajtowych
  		if(!ok) 							//jesli przylozono dobry klucz
       		{if(mode<2) out=~out;			//to w zaleznosci od napiecia na wejsciu AN3, zalacz uklad wyjsciowy
       		 else if(mode>253) out=1;		//jesli napiecie=0, to zmien stan na przeciwny
       		 else 							//jesli napiecie=5V(Vcc), to wlacza uklad wyjsciowy
       		 								//i zostaje w tym stanie do wylaczenia zasilania
       		 	{out=1;						//jesli napiecie na 0<AN3<VCC, to zalacz uklad wyjsciowy
       		 	for(i=mode;i>0;i--)			//na okreslony czas, czas jest zalezny od napiecia na tym wejsciu
       		 		{output_high(green);	//czas ten jest wartoscia przetwornika/4
       		 		delay_ms(125);			//maksymalny czas wynosi 253/4=ok.60sekund
       				output_low(green);		//minimalny czas=2/4=0,5s
       				delay_ms(125);			//w czasie odliczania czsu blyska dioda zielona
       				}
       			out=0;						//i wylacza wyjscie
       			}
        	while(touch_present()) ;		//czekaj na odlaczenie klucza od czytnika
	    	output_high(green);
	    	delay_ms(1000);					//poczekaj jeszcze troche
            output_low(green);
            }
          else
          	{output_high(red);				//jesli blad, to zapal diode czerwona
			 delay_ms(2000);				//poczekaj jeszcze troche
             output_low(red);
             }
     	}
     }

}
//////////////////////////////////////////////////////////////////////////////

//************************************************************************//
//czeka na DS i Odczytuje 8bajtow numeru seryjnego i wpisuje do buffer    //
//************************************************************************//
read_ds()
{int i;
 boolean zero;
while(!touch_present()) ;						//czeka na przylozenie klucza
        touch_write_byte(0x33);					//komenda odczytu numeru serujnego
        zero=0;									//zeruj flage numeru, dla osmiu zer
        for(i=0;i<8;++i)						//odczytaj osiem bajtow
          { buffer[i]=touch_read_byte();		//odczytuje 8bajtow kodu
          if(buffer[i]!=0) zero=1;				//jesli sa same zera, to blad
          }
         if(!zero) return(0xff);				//jesli wszystkie bajty byly zerami, to blad
         if(crc_test(buffer,8)==0) return(0);   //jesli CRC byla ok, to zwraca 0
         else return(0xff);						//jesli blad CRC, to blad wysylanych danych
												//i zwraca 0xff
}
//************************************************************************//


//************************************************************************//
// Procedura zapisu kluczy- maksymalnie 15								  //	                                                                       //
//************************************************************************//
programowanie()
{int i,j,adres;

for(j=0;j<120;j++)							//kasowanie pamieci ds-sow
	write_eeprom(j,0);						//wpisujac wartosc 0
bit_clear(ansel,0);							//ustawia gpio0, jako cyfrowy
for(i=0;i<10;i++)							//blyskaj 10 razy dioda
	{output_high(red);						//czerwona sygnalizujac tryb
	delay_ms(200);							//rejestracji kluczy
	output_low(red);
	delay_ms(200);
	}
j=0;										//zerowanie numeru klucza
prog:
delay_ms(1000);								//poczekaj 1s
output_low(red);							//zgas obie diody
output_low(green);
while(j<15)									//maksymalna ilosc kluczy=15
{
	if(read_ds()==0)						//jesli odczytano numer seryjny
      {adres=j*8;							//to ustal adres w pamieci EEPROM
       for(i=0;i<8;i++)						//i zapisz 8 bajtow numeru
          {write_eeprom(adres,buffer[i]);	//od wskazanego adresu
       	   adres++;
       	  }
       j++;									//przygotuj adres w EEPROM dla natepnego klucza
       while(touch_present()) ;				//czekaj na opdlaczenie pastyli od czytnika
       output_high(green);					//aby nie zapisac kilka razy tej samej pastylki
       goto prog;							//zapal diode zielona i idz na poczatek, do rejestracji
       }									//kolejnego klucza
     else									//jesli przy odczycie DS wystapil blad to
       {output_high(red);					//zapal diode czerwona i tez idz do
       	goto prog;							//rejestracji klucza lecz bez zwiekszania adresu w EEPROM
       }
}
	while(1)								//jesli zapisane wszystkie klucze,
	{										//blyska diodami: czerwona i zielona
	output_high(red);						//kolor zblizony do pomaranczowego
	output_high(green);
	delay_ms(255);
	output_low(red);
	output_low(green);
	delay_ms(255);
	}

}
//************************************************************************//

