////////////////////////////////////////////////////////////////////////////
//  Name    : Wlacznik_telefoniczny.c                               	  //
//  Author  : [Krzysztof Pawsiuk]                                        //
//  Notice  : Copyright (c) 2003                                          //
//  Compil. : CCS PCM C Compiler, Version 3.045, 12391                    //
//  Date    : 2003-04-07                                                  //
//  Version : 1.0                                                         //
//  Notes   :                                                             //
//          :  				                                              //
////////////////////////////////////////////////////////////////////////////
#include <12f629.h>
#include <f629.h>

// 	BG1	BG0	 NC   NC  NC  CPD  CP BODEN MCLR PWRTE WDTE FOSC2 FOSC1 FOSC0
//  13  12   11   10   9   8   7    6    5    4     3     2   1      0
//   1	 1    0	   0   0   1   1    1    0    0     1     1   0      0
//  BG-HVolt             OFF  OFF   ON  PIN  ON    OFF   Int_RC

#rom 0x2007={0b11000111000100}
#use delay(clock=4000000)
#id 0,4,0,7

#define key  	gpio_4				//port klawisza
#define LED		gpio_2				//dioda
#define przek	gpio_1				//wyjscie przekaznika
#define ring	gpio_0				//wejscie dzwonka
#define key_on	gpio_5				//wejscie zezwalajace na zdalne przelaczanie =1, to mozliwe
//#byte		ANSEL=0x09F				//dla pic12f675
#define Timer1_set   0xffff-62500	//500ms=500000*1us=8*62500 ustawienia timera1
int get_ring();
int time;
#define time_out 80					//czas na odebranie drugiego sygnalu dzwonienia dla=80 t=40sekund
boolean ring1_ok;					//flaga odebrania piewszej czesci sygnalu przelaczania

main()
{int i;
trisio=0b11111001;					//konfiguracja trisa
cmcon=7;							//porty jako cyfrowe
bit_clear(option_reg,not_gppu);		//wlacz globalne podciaganie
WPU=0xff;							//wlacz podciaganie dla wszyskich pinow
osccal=0b10110000;					//oscylator
pcon=0;								//
//ansel=0;							//dla pic12f675
przek=0;
led=0;
///--------------------------------------------------------------------
set_timer1(timer1_set);             // sets timer to interrupt in 500ms
t1con=0b00110001;					//tmr1_on, internal,presc/8
bit_set(pie1,tmr1ie);				//wlacza przerwanie od tmr1
intcon|=0b11000000;					//wlacza przerwania globalne
//---------------------------------------------------------------------
ring1_ok=0;							//tryb spoczynkowy
delay_ms(1000);
while(1)
{
if(!key)							//jesli klawisz nacisniety
	{delay_ms(20);					//czekaj 20ms
	if(!key)
		{ring1_ok=0;
		przek=~przek;				//jesli klawisz to zmien stan przekaznika
		led=przek;					//jesli przekaznik wlaczony, to zapal diode
		while(!key);
		}
	}
if(key_on)							//jesli wlaczone zdalne przelaczanie
	{if(!ring1_ok&&get_ring()==1)	//jesli tryb spoczynku i wystapil 1dzwonek
		{ring1_ok=1;				//przejscie do trybu drugiego
		time=0;						//zeruj licznik czasu
		}
	if(ring1_ok)					//jesli tryb drugi
		{i=get_ring();				//odbierz dzwonki
		if(i==1)					//jesli wystapil 1dzwonek
			{ring1_ok=0;			//przelacz w tryb spoczynku
			przek=~przek;			//zmien stan przekaznika na przeciwny
			led=przek;				//jesli przekaznik wlaczony, to zapal diode
			}
		else if(i>1) 				//jesli bylo >dzwonkow
			{ring1_ok=0;			//przelacz w tryb spoczynku
			led=przek;				//jesli przekaznik wlaczony, to zapal diode
			}
		}
	}
}

}

//************************************************************************//
//sprawdza czy bylo dzwonienie, jesli tak to liczy dzwonki i zwraca ich   //
//ilosc, jesli wystapi pierwszy krotki dzwonek, to w ciagu 2sekund centrala
//wysyla ponownie dzwonienie ty razem juz pelne, procedura traktuje ten   //
//stan jako jeden dzwonek												  //
//************************************************************************//
int get_ring()
{int i,k;
if(ring)	return(0);					//jesli nie ma dzwonka
k=0;									//zeruj liczbe dzwonkow
ring_1:
	i=0;
	while(++i<250)						//jesli wystapil dzwonek, to przez 2 sekundy
		{delay_ms(8);					//sprawdzaj czy nadal jest dzwonienie
 		if(!ring) i=0;					//jesli jest to czekaj na koniec. czas oczekiwania
 		}								//
	if(++k>250) k=250;					//zwieksz liczbe dzwonkow, max. 250 dzwonkow
	i=0;
	while(++i<250)						//jeszcze przez 3sekundy czekaj na nastepny dwonek
		{delay_ms(12);					//jesli nie bedzie, to dzwonienie zakonczone
		if(!ring) goto ring_1;			//jesli jest dzwonienie, to czekaj na koniec sygnalu
		}
return(k);								//zwroc liczbe dzwonkow
}
//************************************************************************//

//*******************************************************************************************
//			Obsluga przerwania od T1
//*******************************************************************************************
#INT_TIMER1
void wave_timer()
{
set_timer1(timer1_set);             // sets timer to interrupt in 500ms

if(ring1_ok)						//jesli odebrano 1dzwonek, to
	{led=~led;						//blyskaj dioda
	if(++time>time_out) 			//jesli przekroczono czas max oczekiwania
		{time=0;					//na drugi sygnal dzwonienia to zeruj czas i
		ring1_ok=0;					//przelacz w tryb spoczynku
		led=przek;					//przywroc stan diody
		}
	}
}
////////////////////////////////////////////////////////////////////////////
