
// P16F84A.INC  Standard Header File, Version 2.00    Microchip Technology, Inc.
     #NOLIST
//;----- Register Files------------------------------------------------------

#byte INDF                         =     0x000
#byte TMR0                         =     0x001
#byte PCL                          =     0x002
#byte STATUS                       =     0x003
#byte FSR                          =     0x004
#byte PORTA                        =     0x005
#byte PORTB                        =     0x006
#byte EEDATA                       =     0x008
#byte EEADR                        =     0x009
#byte PCLATH                       =     0x00A
#byte INTCON                       =     0x00B

#byte OPTION_REG                   =     0x081
#byte TRISA                        =     0x085
#byte TRISB                        =     0x086
#byte EECON1                       =     0x088
#byte EECON2                       =     0x089

#bit  porta_0                      =     0x5.0
#bit  porta_1                      =     0x5.1
#bit  porta_2                      =     0x5.2
#bit  porta_3                      =     0x5.3
#bit  porta_4                      =     0x5.4
//#bit  porta_5                      =     0x5.5
//#bit  porta_6                      =     0x5.6
//#bit  porta_7                      =     0x5.7
#bit  trisa_0                      =     0x85.0
#bit  trisa_1                      =     0x85.1
#bit  trisa_2                      =     0x85.2
#bit  trisa_3                      =     0x85.3
#bit  trisa_4                      =     0x85.4
//#bit  trisa_5                      =     0x85.5
//#bit  trisa_6                      =     0x85.6
//#bit  trisa_7                      =     0x85.7

#bit  portb_0                      =     0x6.0
#bit  portb_1                      =     0x6.1
#bit  portb_2                      =     0x6.2
#bit  portb_3                      =     0x6.3
#bit  portb_4                      =     0x6.4
#bit  portb_5                      =     0x6.5
#bit  portb_6                      =     0x6.6
#bit  portb_7                      =     0x6.7
#bit  trisb_0                      =     0x86.0
#bit  trisb_1                      =     0x86.1
#bit  trisb_2                      =     0x86.2
#bit  trisb_3                      =     0x86.3
#bit  trisb_4                      =     0x86.4
#bit  trisb_5                      =     0x86.5
#bit  trisb_6                      =     0x86.6
#bit  trisb_7                      =     0x86.7







//;----- STATUS Bits --------------------------------------------------------

#define  IRP                                 	 0x07
#define  RP1                                    0x06
#define  RP0                                    0x05
#define  NOT_TO                                 0x04
#define  NOT_PD                                 0x03
#define  Z                                      0x02
#define  DC                                     0x01
#define  C                                      0x00

//;----- INTCON Bits --------------------------------------------------------

#define  GIE                                   0x07
#define  EEIE                                  0x06
#define  T0IE                                  0x05
#define  INTE                                  0x04
#define  RBIE                                  0x03
#define  T0IF                                  0x02
#define  INTF                                  0x01
#define  RBIF                                  0x00

//;----- OPTION_REG Bits ----------------------------------------------------

#define  NOT_RBPU                               0x07
#define  INTEDG                                 0x06
#define  T0CS                                   0x05
#define  T0SE                                   0x04
#define  PSA                                    0x03
#define  PS2                                    0x02
#define  PS1                                    0x01
#define  PS0                                    0x00

//;----- EECON1 Bits --------------------------------------------------------

#define  EEIF                                   0x04
#define  WRERR                                  0x03
#define  WREN                                   0x02
#define  WR                                     0x01
#define  RD                                     0x00


  /*
;==========================================================================
;
;       RAM Definition
;
;==========================================================================

        __MAXRAM H'CF'
        __BADRAM H'07', H'50'-H'7F', H'87'

;==========================================================================
;
;       Configuration Bits
;
;==========================================================================

_CP_ON                       EQU     H'000F'
_CP_OFF                      EQU     H'3FFF'
_PWRTE_ON                    EQU     H'3FF7'
_PWRTE_OFF                   EQU     H'3FFF'
_WDT_ON                      EQU     H'3FFF'
_WDT_OFF                     EQU     H'3FFB'
_LP_OSC                      EQU     H'3FFC'
_XT_OSC                      EQU     H'3FFD'
_HS_OSC                      EQU     H'3FFE'
_RC_OSC                      EQU     H'3FFF'
  */
#LIST
