
////////////////////////////////////////////////////////////////////////////
//  Name    : RS485_wyswietl_lcd.c                                  	  //
//  Author  : [Krzysztof Pawsiuk]                                        //
//  Notice  : Copyright (c) 2002 	                                      //
//  Compil. : CCS PCM C Compiler, Version 3.045, 12391                    //
//  Date    : 2003-01-05                                                  //
//  Version : 1.0                                                         //
//  Notes   :                                                             //
//          :  					                                          //
////////////////////////////////////////////////////////////////////////////
#include <16f628.h>
#include <f628.h>
// 			DEBUG     WRT CPD LVP BODEN CP1 CP0 PWRTE WDTE FOSC1 FOSC0
//  13  12   11   10   9   8   7    6    5   4    3     2   1      0
#rom 0x2007={0b11110101100101}	//bezpieczniki

#use delay(clock=4000000,RESTART_WDT)
#use rs232(baud=1200, xmit=PIN_b2,rcv=pin_b1,enable=pin_b0)  // port szeregowy
#id 0,1,0,3

#rom 0x2100={'3'}						//adres urzadzenia

#include<lcd.h>
#define esc	27							//znacznik poczatku transmisji danych(zerowanie)
#define enter 0x0D						//znacznik konca transmisji pakietu danych
#define enable pin_b0
#define jp1 pin_a3						//zworka zmiany adresu urzadzenia
#define jp2 pin_a4						//zworka przywracania adresu urzadzenia
#define master_adr 0
int master;								//tu umieszczony jest adrs glowny modulu, adres ten
										//jest odczytywany z eeprom i moze zostac zmieniony
										//przez zapis w eeprom, np. prze przeprogramowanie eeprom
int lc[32];								//bufor znakow LCD
int lok;								//pozycja kursora w buforze lc
GetRs485();								//odbiera dane z rs485
zmien_master();							//zmienia kod urzadzenia

/////////////////////////////////////////////////////////////////////////////
main()
{
int i;

//jesli byl normalny start
//---------------------------------------------------------------------------
if(bit_test(status,not_to))				//jesli normaly start to zeruj port
	{
	output_low(pin_a1);
	setup_wdt(WDT_2304MS);
	output_low(pin_b3);
	port_b_pullups(true);
	if(!input(jp1)) zmien_master();			//jesli jp1 zwarte to idz do zmiany adresu urzadzenia
	if(!input(jp2)) write_eeprom(master_adr,'3'); //jesli jp2=0, to przywroc poczatkowy adres
	master=read_eeprom(master_adr);			//odczytuje adres master z eeprom
	cmcon=7;								//porta jako cyfrowy

	lcd_init();								//inicjalizacja LCD
	lcd_putc('\r');
	lcd_znaki();							//inicjalizacja kolskich znakw
	lok=0;									//zeruje ustawienie kursora w buforze lc

	memset(lc,' ',32);						//wpisz spacje do bufora lcd
	setup_ccp1(CCP_PWM);   					//Konfiguracja CCP1 jako PWM
	set_timer2(0);
	setup_timer_2(T2_DIV_BY_16, 8, 1);		//konfiguracja Tmr2
	set_pwm1_duty(0);						//wycza podwietlanie

	}										//jesli reset WDT, to pozostaw porty jakie byly
//-------------------

while(1)
	{
	if(kbhit())								//jesli rozpoczeto wysylanie danych
	    if(getc()==esc) GetRs485(); 		//jesli wyslano esc to idz do obslugi
	restart_wdt();							//reset wdt
	}
}
/////////////////////////////////////////////////////////////////////////////

/////////Zmienia adres master///////////////////////////////////////////////
zmien_master()
{	int i;
//	output_high(enable);				//przelaczanie nadajnika jest automatyczne, przez printf
	printf("\rAktualny adres urzdzenia=%C",read_eeprom(master_adr));
	printf("\n\rAby zmieni ten adres nacinij klawisz nowego adresu");
//	output_low(enable);
	while(1)							//glowna petla
		{

		if(kbhit())						//jesli rozpoczeto wysylanie danych
			{i=getc();
			write_eeprom(master_adr,i);
			printf("\rNowy adres urzdzenia=%C",read_eeprom(master_adr));
			sleep();
			}
		restart_wdt();					//reset wdt
 	}
}
///////////////////////////////////////////////////////////////////////////

//************************************************************************//
//   wypisuje tekst z bufora lc na lcd                                    //
//************************************************************************//
lcd_buf()
{int i;
	lcd_gotoxy(1,1);			//ustat kursor na pierszej pozycji
 	for(i=0;i<=15;i++)			//iwpisz text na pierwszej linii
		lcd_putc(lc[i]);
	lcd_gotoxy(2,1);			//ustaw kursor na drugiej linii
	for(i=16;i<=31;i++)		    //i wpisz tekst na drugiej linii
	 	lcd_putc(lc[i]);
}
//************************************************************************//


//************************************************************************//
//  Odbiera dane z RS485,analizuje i odpowoenio steruje portem            //
//************************************************************************//
GetRS485()
{
int in,i,j, buf[8];

rs485_1:

	i=0;in=0;

//-------------------------------------------------------------------------
while(1)
	{restart_wdt();
//-----------------------------------------------------------------

	if(kbhit()) 								//jesli wysylane sa znaki
		{in=getc();								//to odbierz znak i zapisz w in
		if(in==esc) goto rs485_1;				//jesli in=esc, to idz do poczatku procedutry
	//----------------------------------------------------------
		if(in!=enter)
			{buf[i]=in;
			if(buf[0]!=master) return;			//jesli zly adres master
			}
		else									//jesli nacisnieto enter
		 	{

//------------------------------------------------
//jesli W to wpisuje to zapis do urzadzenia
		if(buf[1]=='w'||buf[1]=='W')    		//jesli ma byc zapis do urzadzenia
			{
//jesli buf2=1 to powrot na piersza linie
		 	if(buf[2]=='1') lok=0;				//jesli buf2=1 to kursor na poczatek 1 linii

//jesli buf2=2 to kursor na druga linie
		 	else if(buf[2]=='2') lok=16;		//jesli 2,to druga linia
//jesli c to czysci lcd
			else if((buf[2]=='c'||buf[2]=='C')) //jesli buf3=c to kasuj lcd
				{memset(lc,' ',32);				//wpisz spacje do bufora lcd
				lcd_buf();
				lok=0;
		 		}
//jesli l to ustawienie podswietlania
			else if(buf[2]=='l'||buf[2]=='L')	//jesli l to ustaw podswietlanie
					{set_pwm1_duty(buf[3]&0x0f);//podane dalej w buf3 0...9
												//0-wylaczone, 9- max
					}

//jesli D to zapis danych do lcd
		 	else if(buf[2]=='d'||buf[2]=='D')	//jesli buf2=d to zapisuje dane do lcd znaki
		 			{
		 			while(1)
		 				{
		 				restart_wdt();			//reset wdt
		 				if(kbhit())
		 					{in=getc();
		 					if(in==esc) goto rs485_1;	   //jesli nacisnieto esc to powrot do pocztku procedury
		 			    	else
		 			    		{lc[lok]=in;	//zapisz odebrany znak do bufora
		 			    		if(++lok>31) lok=0;
		 			    		lcd_buf();}
		 			     	}
		 				}
		 			 }
		 	 return;
		 	}
//--------------------------------------------------------------------------

//jesli ma byc odczyt z urzadzenia
	 		if(buf[1]=='r'||buf[1]=='R')
				{delay_us(100);					//odczekaj az nadajnik, przelaczy sie w odbior
///jesli a to odczyt wszystkich znakow 32bajty
				 if(buf[2]=='a'||buf[3]=='A')	//jesli ma odczytac stan	wszystkie znaki
				   	  for(j=0;j<32;j++)
				   		  printf("%c",lc[j]);

//jesli 1 to odczyt 1 linii 16bajtow
				 else if(buf[2]=='1')			//jesli ma odczytac 1 linie
						for(j=0;j<=15;j++)
				   		  	printf("%c",lc[j]);

//jesli 2 to odczyt 2 linii 16bajtow
				 else if(buf[2]=='2')			//jesli ma odczytac 2linie
						for(j=16;j<=31;j++)
							printf("%c",lc[j]);

//jesli l to odczyt podswietlania 1bajt
				else if(buf[2]=='l'||buf[2]=='L')
						putc(ccpr1l+'0');		//wyslij wartosc pwm

				return;							//powrot

			}
	 		else return;  						//jesli inny to nic nie rob tylko powrot

//--------------------------------------------------
		 	}
		 if(++i>3) i=0;							//jesli odebrano wiecej niz 4znaki to powrot
	//---------------------------------------------------
		}
  //-----------------------------------------------------------------
	}
//--------------------------------------------------------------------------
}
////////////////////////////////////////////////////////////////////////////

