////////////////////////////////////////////////////////////////////////////
//  Name    :RS485_Wyswieltlacz_LED.c                                 	  //
//  Author  : [Krzysztof Pawsiuk]                                        //
//  Notice  : Copyright (c) 2002 	                                      //
//  Compil. : CCS PCM C Compiler, Version 3.045, 12391                    //
//  Date    : 2002-12-11                                                  //
//  Version : 1.0                                                         //
//  Notes   : Adres master='2', 				                          //
//          : predkosc 1200b                                              //
////////////////////////////////////////////////////////////////////////////
#include <16f872.h>
#include <f872.h>
// 			DEBUG     WRT CPD LVP BODEN CP1 CP0 PWRTE WDTE FOSC1 FOSC0
//  13  12   11   10   9   8   7    6    5   4    3     2   1      0
#rom 0x2007={0b00100101110101}					//bezpieczniki

#use delay(clock=4000000,RESTART_WDT)
#use rs232(baud=1200, xmit=PIN_c6, rcv=PIN_c7)  // konfiguracja transmisji szeregowej
#id 1,2,0,2

#rom 0x2100={'2'}								//adres urzadzenia

#define esc	27									//znacznik poczatku transmisji danych(zerowanie)
#define enter 0x0D								//znacznik konca transmisji pakietu danych
#define master_adr	0							//adres zapisany w eeprom glownego modulu, adres slave zalezy od zworek JP1,JP2
#define enable pin_c5							//ustala kierunek transmisji =0 odbior, =1 nadawanie
#define jp1	pin_c1								//zworki do ustalenia adresu slave
#define jp2	pin_c0
#define DataPort	portb						//port wysylania danych
#define DataTris	trisb						//tris danych
#define AnodePort	porta						//port sterowania anod
#define AnodeTris	trisa						//A1=PA3, A2=RA2,A3=RA1, A3=RA0

#define Timer1_set   0xffff-250   				//2ms=1000*1us=8*250 ustawienia timera1 dla 4cyfr f=125Hz dla jednej cyfry

int DpNr;										//numer wyswietlanego wyswietlacza
int LED[4];										//bufor wyswietlanych cyfr
int krop[4];									//kropki na wyswietlaczach

zmien_master();
GetRS485();
int master;										//tu umieszczony jest adrs glowny modulu, adres ten
												//jest odczytywany z eeprom i moze zostac zmieniony
												//przez zapis w eeprom, np. przez przeprogramowanie eeprom
//0,1,2,3,4,5,6,7,8,9, ,-
byte const LedC[12]={0b11000000,0b11111001,0b10100100,0b10110000,0b10011001,
				0b10010010,0b10000010,0b11111000,0b10000000,0b10010000,
				0b11111111,0b10111111,};



/////////////////////////////////////////////////////////////////////////////
main()
{
//jesli byl normalny start
//---------------------------------------------------------------------------
if(bit_test(status,not_to))						//jesli normaly start to zeruj port
	{DataPort=0xff;								//na wyjscia danych wpisz 0xff, gasi wszystkie katody
	 Anodeport|=0x0f;							//gasi wsystkie anody
	 DpNr=0;									//zeruj numer wyswietlacza
     LED[0]=10;LED[1]=10;LED[2]=10;LED[3]=10;	//wygas wszystkie wyswietlacze
     krop[0]=0xff;krop[1]=0xff;krop[2]=0xff;krop[3]=0xff;
 	 set_timer1(timer1_set); 					//ustaw startowa wartosc timera1
	}											//jesli reset WDT, to pozostaw porty jakie byly
//-----------------------------------------------------------------------------

setup_wdt(WDT_2304MS);
output_low(enable);								//MAX485 w trybie odbioru
DataTris=0;										//port danych jako wyjscie
AnodeTris&=0xf0;								//wyjscia sterowania anodami jako wyjscia
if(!input(jp1)) zmien_master();					//jesli jp1 zwarte to idz do zmiany adresu urzadzenia
if(!input(jp2)) write_eeprom(master_adr,'2'); 	//jesli jp2=0, to przywroc poczatkowy adres
master=read_eeprom(master_adr);					//odczytuje adres master z eeprom

setup_timer_1(T1_INTERNAL|T1_DIV_BY_8);  		// Ustawia Tmr1 z preskalerem/8
enable_interrupts(INT_TIMER1);					//wlacza przerwanie od Tmr1
enable_interrupts(GLOBAL);						//wlaca przerwania globalne

while(1)										//glowna petla
	{

	if(kbhit())									//jesli rozpoczeto wysylanie danych
		if(getc()==esc) GetRs485(); 			//jesli wyslano esc to idz do obslugi
	restart_wdt();								//reset wdt
 	}
}
/////////////////////////////////KONIEC   MAIN//////////////////////////////




//************************************************************************//
// Obsluga wyswietlaczy w przerwaniu od Tmr1 co 1ms                       //
//************************************************************************//
#INT_TIMER1
void wave_timer()
{  int i;
   disable_interrupts(int_timer1);				 //wylacza przerwanie od Tmr1
   set_timer1(timer1_set);                       //ustaw stan poczatkowy Tmr1
   AnodePort|=0x0f;								 //wylacz wszystkie wyswietlacze
   dataPort=ledC[led[DpNr]&0x0f];				 //wystawia na katody dane dla wysw.
   dataPort&=krop[DpNr];						 //podanego w DpNr i kropke
   switch(DpNr)									 //w zaleznosci od numeru wyswietlacza
   	{											 //ustawia stan wysoki na odpowiedniej
   	case 0: AnodePort&=0b11110111;break;		 //Anodzie
   	case 1: AnodePort&=0b11111011;break;
   	case 2: AnodePort&=0b11111101;break;
   	case 3: AnodePort&=0b11111110;break;
   	}
   if(++DpNr>3) DpNr=0;							 //jesli zwiekszony nr wyswietl. >3 to zeruj
   enable_interrupts(int_timer1);				 //wlacza przerwanie od Tmr1

}
//************************************************************************************//

//************************************************************************//
//  Odbiera dane z RS485,analizuje i odpowoenio steruje portem            //
//************************************************************************//
GetRS485()
{
int in,i,j, buf[8];

rs485_1:

	i=0;in=0;

//-------------------------------------------------------------------------
while(1)
	{restart_wdt();
//-----------------------------------------------------------------

	if(kbhit()) 								//jesli wysylane sa znaki
		{in=getc();								//to odbierz znak i zapisz w in
		if(in==esc) goto rs485_1;				//jesli in=esc, to idz do poczatku procedutry
		if(in!=enter)
			{if(in=='-') in=11;					//jesli minus to przeksztalc na minus wyswietlacza
			 if(in==' ') in=10;					//jesli + to wygasza wyswietlacz
			 buf[i]=in;
			if(buf[0]!=master) return;			//jesli zly adres master
			}
		else									//jesli nacisnieto enter
		 	{

//jesli W to wpisuje to zapis do urzadzenia
			if(buf[1]=='w'||buf[1]=='W') 		//jesli ma byc zapis do urzadzenia
			{
	//jesli buf[2]=c to zapis cyfr
				if(buf[2]=='c'||buf[2]=='C')  	//jesli maja byc wpisane wszystkie cyfry
		 			{if(buf[3]=='a'||buf[3]=='A')//to przepisz z buf do led wszystkie cyfry
		 				{
		 				Led[0]=buf[4]&0x0f;		//to zamien na dziesietne i przepisz
		 				Led[1]=buf[5]&0x0f;		//do bufora Led
		 				Led[2]=buf[6]&0x0f;
		 				Led[3]=buf[7]&0x0f;
		 				}						//w przeciwnym przypadku przepisz tylko cyfre podana
		 			else 	led[buf[3]-'1']=buf[4]-'0';		//na pozycje podana w buf3 w pisuje dana podana na pozycji buf 4
		 			return;
		 			}
//jesli k to wpisuje kropki na podane pozycje
		 		else if(buf[2]=='k'||buf[2]=='K')	   //jesli ma ustawic przecinki
		 				{if(buf[3]=='a'||buf[3]=='A')  //jesli wszystkie to przepisz wszystkie przecinki
		 			  		{if(buf[4]=='1') krop[0]=0b01111111;     //jesli 1 to zapal w pierwszym wyswietl
		 			   		else krop[0]|=0b11111111;  //jesli 0 to zgas w pierwszym wyswietl
		 			   		if(buf[5]=='1') krop[1]=0b01111111;     //jesli 1 to zapal w drugim wyswietl
		 			   		else krop[1]|=0b11111111;  //jesli 0 to zgas w drugim wyswietl
		 			   		if(buf[6]=='1') krop[2]=0b01111111;     //jesli 1 to zapal w trzecim wyswietl
		 			   		else krop[2]|=0b11111111;  //jesli 0 to zgas w trzecim wyswietl
		 			   		if(buf[7]=='1') krop[3]=0b01111111;     //jesli 1 to zapal w czwartym wyswietl
		 			   		else krop[3]|=0b11111111;  //jesli 0 to zgas w czwartym wyswietl
		 			  	}
		 				else						   //jsli zmiana tylko jednej kropki, to w pisz na podany
		 					{if(buf[4]=='1') krop[buf[3]-'1']=0b01111111; //numer 0 lub1,  w zaleznosci od podanej cyfry
		 				 	else krop[buf[3]-'1']=0b11111111;
		 					}
		 				return;
		 				}
		 	}
//jesli ma byc odczyt z urzadzenia
	 		if(buf[1]=='r'||buf[1]=='R')		   	   //jesli ma odczytac stan
				{
				delay_us(100);						   //czekaj az nadajnik powroci do trybu odbioru
				output_high(enable);				   //przelacz MAX495 w tryb nadawania
	//jesli ma byc odczyt cyfr
				if(buf[2]=='c'||buf[2]=='C')
				   {if(buf[3]=='a'||buf[3]=='A')
				   	  {for(j=0;j<=3;j++)
				   			{if(led[j]==11) putc('-');
				   		 	else if(led[j]==10) putc(' ');
				   		 	else printf("%u",led[j]);
				   		 	}
				   	  }
					else
						{buf[3]-='1';
						if(led[buf[3]]==11) putc('-');
						 else if(led[buf[3]]==10) putc(' ');
						 else printf("%u",led[buf[3]]);
						}
					 output_low(enable);			 //przelacz MAX485 w tryb odbioru
					 return;						 //powrot

					 }
//---------------------------------------------------------------------------
	//jesli ma byc odczyt kropek
				else if(buf[2]=='k'||buf[2]=='K')
				   {if(buf[3]=='a'||buf[3]=='A')
				   		{
						if(krop[0]==0b01111111) putc('1');      //jesli 1 to zapal w pierwszym wyswietl
						else putc('0');			   //jesli 0 to zgas w pierwszym wyswietl
						if(krop[1]==0b01111111) putc('1');     //jesli 1 to zapal w drugim wyswietl
						else putc('0');			   //jesli 0 to zgas w drugim wyswietl
						if(krop[2]==0b01111111) putc('1');     //jesli 1 to zapal w trzecim wyswietl
						else putc('0');			   //jesli 0 to zgas w trzecim wyswietl
						if(krop[3]==0b01111111) putc('1');     //jesli 1 to zapal w czwartym wyswietl
		 				else putc('0');
						output_low(enable);						//przelacz MAX485 w tryb odbioru
						return;									//powrot
						}
					else
						{if(krop[buf[3]-'1']==0b01111111) putc('1');
						else if(krop[buf[3]-'1']==0b11111111) putc('0');
						}
					output_low(enable);					//przelacz MAX485 w tryb odbioru
					 return;							//powrot
					}

				}
		 		else return;  							//jesli inny to nic nie rob tylko powrot

		 //--------------------------------------------------
		 	}
		 if(++i>7) i=0;									//jesli odebrano wiecej niz 4znaki to powrot
	//---------------------------------------------------
		}
  //-----------------------------------------------------------------
	}
//--------------------------------------------------------------------------
}
////////////////////////////////////////////////////////////////////////////



//************************************************************************//
// Procedura zmienia adres master                                         //
//************************************************************************//
zmien_master()
{	int i;
	output_high(enable);
	printf("\rAktualny adres urzdzenia=%C",read_eeprom(master_adr));
	printf("\n\rAby zmieni ten adres nacinij klawisz nowego adresu");
	output_low(enable);
	while(1)							//glowna petla
		{

		if(kbhit())						//jesli rozpoczeto wysylanie danych
			{i=getc();
			write_eeprom(master_adr,i);
			output_high(enable);
			printf("\rNowy adres urzdzenia=%C",read_eeprom(master_adr));
			output_low(enable);
			sleep();
			}
		restart_wdt();					//reset wdt
 	}
}
/////////////////////////////////////////////////////////////////////////////









